package Http_Urls is

--    ^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?
--     12            3  4          5       6  7        8 9
--    http://www.ics.uci.edu/pub/ietf/uri/#Related
--    $1 = http:
--    $2 = http
--    $3 = //www.ics.uci.edu
--    $4 = www.ics.uci.edu
--    $5 = /pub/ietf/uri/
--    $6 = <undefined>
--    $7 = <undefined>
--    $8 = #Related
--    $9 = Related

  function Scheme(Url     : String;
                  Base_Url: String := "") return String;
  --    http://www.ics.uci.edu/pub/ietf/uri/#Related
  -- "http:"
  -- return "http:" if no host part in either URL or Base_URL

  function Host(Url     : String;
                Base_Url: String := "") return String;
  --    http://www.ics.uci.edu/pub/ietf/uri/#Related
  -- //www.ics.uci.edu
  -- return "" if neither URL nor Base_URL has a host
  -- NOTE: A legal http url must have a non-null host

  function Path(Url     : String;
                Base_Url: String := "") return String;
  --    http://www.ics.uci.edu/pub/ietf/uri/#Related
  -- /pub/ietf/uri/
  --    http://www.ics.uci.edu/pub/ietfsomething
  -- /pub/ietf/something
  -- result'length >= 1
  -- result(result'first) = '/'

  function Query(Url     : String;
                 Base_Url: String := "") return String;
  --    http://www.ics.uci.edu/pub/ietf/uri/#Related
  -- ""
  -- return "?whatever" or ""

  function Fragment(Url     : String;
                    Base_Url: String := "") return String;
  --    http://www.ics.uci.edu/pub/ietf/uri/#Related
  -- #Related
  -- return "#whatever" or ""

  function Portless_Host(Host : String) return String;
  -- Strips off any trailing :nn

  function Port(Host : String) return Natural;
  -- Returns value of any trailing :nn, or zero

end Http_Urls;
