
generic
  type IDs is (<>);
package Str_Sto.Store is

  function Count return String_Counts;
  -- return the number of distinct strings in this instantiation.

  function Is_Present(S : in String) return Boolean;
  -- Just check if it's already present in store.

  function Put(S : String) return IDs;
  -- Add to store if it isn't there yet.  Return new or old ID.
  -- Raise Overflow if too many or too long strings.

  function Get_Length(ID : IDs) return Natural;

  function Get(ID : IDs) return String;
  -- raise Nonesuch if no such ID.

  function "<"(Left, Right : IDs) return Boolean;

  type Order_Natural is range 0 .. String_Counts'last;
  subtype Order_Positive is Order_Natural range 1 .. Order_Natural'last;

  type Ordered_Lists is array(Order_Positive range <>) of IDs;

  function Get_Ordered_Contents return Ordered_Lists;
  -- returns array of all String_Indices in table, in order.

end Str_Sto.Store;
