package Str_Sto is
  Overflow : exception;  -- Attempt to Add too many strings,
                         -- or too many characters of strings.
  Nonesuch : exception;  -- Attempt to Get non-existent ID.

  type String_Counts is range 0 .. 65_000;
  subtype String_Indices is String_Counts range 1 .. String_Counts'last;

  function Count return String_Counts;
  -- return number of stored strings.

  function Add(S : in String) return String_Indices;
  -- Add to store.  Return new index.
  -- Raise Overflow if too many or too long strings.

  function Get_Length(Index : in String_Indices) return Natural;
  -- raise Nonesuch if no such string.

  function Get(Index : in String_Indices) return String;
  -- raise Nonesuch if no such string.

  type Comparisons is (LT, EQ, GT);
  function Compare(Index : in String_Indices; S : in String)
  return Comparisons;

  function Compare(Left, Right : in String_Indices)
  return Comparisons;

end Str_Sto;
